///////////////
// LIVE PAGE //
///////////////
function getConfigurationValues(configuration, dict, dictlist)
{
	if(Array.isArray(configuration)){
		if(configuration.length>0){
			$.each(configuration[1], function(i, item)
			{
				dict[item.id] = item.description;
			});
			$.each(configuration[0], function(i, item)
			{
				dictlist["[" + item.id + "]"] = item.description;
			});
		}
	}	
}

function getConfigurations(dict, dictlist)
{
	var configLists = executeCGI(computerid, "getconfig", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
	getConfigurationValues(configLists, dict, dictlist);
}

var FIXED_NUMBER_OF_COLUMNS = 4;

function calculateFactorWidthFields(LaneVisible, DirectionVisible, SpeedVisible, ConfVisible, HeightVisible, CountryVisible, ListVisible, ClassVisible, ColorVisible, MakeVisible){
	var numberOfVisibleFields = FIXED_NUMBER_OF_COLUMNS;
	var numberOfFields = FIXED_NUMBER_OF_COLUMNS;
	var returnedFactor;

	if(LaneVisible) numberOfVisibleFields++;
	numberOfFields++;
	if(DirectionVisible) numberOfVisibleFields++;
	numberOfFields++;
	if(ConfVisible) numberOfVisibleFields++;
	numberOfFields++;
	if(HeightVisible) numberOfVisibleFields++;
	numberOfFields++;
	if(CountryVisible) numberOfVisibleFields++;
	numberOfFields++;
	if(ListVisible) numberOfVisibleFields++;
	numberOfFields++;

	var application = "";
	application = getApplication();

	if ((DEFINE_INTERFACE == "VIVOTEK"  || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "ZKTECO") && (application != "eVivotek"))
	{
		if(SpeedVisible) numberOfVisibleFields++;
			numberOfFields++;
	}

	if(DEFINE_INTERFACE == "VIVOTEK_CV25")
	{
		if(ColorVisible || ClassVisible) numberOfVisibleFields++;
		numberOfFields++;
		if(MakeVisible) numberOfVisibleFields++;
		numberOfFields++;
	}

	returnedFactor = numberOfFields/numberOfVisibleFields;

	if(DEFINE_INTERFACE != "ZKTECO")
	{
		if(returnedFactor > 1.2)
		{
			returnedFactor = 1.2;
		}
		else
		{
			if(returnedFactor < 1.1)
			{
				returnedFactor = 1;
			}
		}
	}

	return returnedFactor;
}

$(function()
{
	function parseGeneralConfiguration(isJson, data)
	{
		if(isJson == false)
		{
			try {  
				data = JSON.parse(data); 
			} catch (e) {  
				console.log('invalid json'); 
				return; 
			}
		}

		CheckTokenValidity(data);

		$.each(data, function(i, item)
		{
			if (item.name == "viewlive")
			{
				visorType = item.value;
			}
			if (item.name == "listfields")
			{
				LaneVisible = item.value.includes("Lane");
				DirectionVisible = item.value.includes("Direction");
				SpeedVisible = item.value.includes("Speed");
				ConfVisible = item.value.includes("Conf");
				HeightVisible = item.value.includes("Height");
				CountryVisible = item.value.includes("Country");
				ListVisible = item.value.includes("List");				
				ClassVisible = item.value.includes("Class");
				ColorVisible = item.value.includes("Color");
				MakeVisible = item.value.includes("Make");
				factorOfWidthFields = calculateFactorWidthFields(LaneVisible, DirectionVisible, SpeedVisible, ConfVisible, HeightVisible, CountryVisible, ListVisible, ClassVisible, ColorVisible, MakeVisible);
			}
		});

		gettingGeneralConfiguration = false;
	}

	function callGetGeneralConfiguration() 
	{
		var generalConfiguration;

		generalConfiguration = executeCGI(computerid, "select|table=nlconfgeneral|camp0=id|comp0=major|value0=12|maxvalues=100", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
	
		parseGeneralConfiguration(true, generalConfiguration);
	}

	function clickBody()
	{
		if (testFirstClick) 
		{
			if(ie == false)
			{
				getRTSPStream(rtspURL);
			}

			testFirstClick = false;
		}
	}

	function reDrawCanvas()
	{
		var canvas = document.getElementById('canvas');
		var ctx = canvas.getContext('2d');

		if (showroi && !viconresolution)
		{
			if (roiwidth != 0)
			{
				ctx.beginPath();
				var ppcX = parseFloat("0." + roileft);
				var ppcY = parseFloat("0." + roitop);
				var ppcwidth = parseFloat("0." + roiwidth);
				var ppcheight = parseFloat("0." + roiheight);
				ctx.rect(ppcX * wdefined, ppcY * hdefined, ppcwidth * wdefined, ppcheight * hdefined);
				ctx.strokeStyle = 'red';
				ctx.lineWidth = 5;
				ctx.stroke();
			}
		}

		if (showlanes && !viconresolution)
		{
			if (haveLanes)
			{
				ctx.beginPath();
				ctx.strokeStyle = 'blue';
				ctx.lineWidth = 2;
				ctx.moveTo(p0, 0);
				ctx.lineTo(p1, hdefined);
				ctx.stroke();
			}
		}

		if (showpattern && !viconresolution)
		{
			var linedraw = Math.round((25 * hdefined) / resy);
			ctx.beginPath();
			ctx.strokeStyle = 'white';
			ctx.lineWidth = 2;
			for (i = 0; i < hdefined; i += linedraw)
			{
				ctx.moveTo(0, i);
				ctx.lineTo(wdefined, i);
				ctx.stroke();
			}
		}

		if (showcrossline && !viconresolution)
		{
			if (haveCrossline)
			{
				for (var i=0; i<numCrossline; i++)
				{
					ctx.beginPath();
					ctx.strokeStyle = 'green';
					ctx.lineWidth = 2;
					ctx.moveTo(x0[i], y0[i]);
					ctx.lineTo(x1[i], y1[i]);
					ctx.stroke();
					
					ctx.beginPath();
					ctx.rect(clarea1[i], clarea2[i], clarea3[i], clarea4[i]);
					ctx.strokeStyle = 'green';
					ctx.lineWidth = 5;
					ctx.stroke();
				}
			}
		}
	}

	function callToGetTimeCamera() 
	{
		d2 = getimeCamera();
		d2.setMinutes(d2.getMinutes() - 5);
	}

	function loadStatusValues()
	{
		var time = "";
		status.forEach(function(info, elem)
		{
			var title = DevExpress.localization.formatMessage(info.text);
			if (info.ident == "service")
			{
				var ee = info.text.split(";")
				if (ee.length > 1)
				{
					title = DevExpress.localization.formatMessage(ee[0]) + ee[1];
				}
				else
				{
					title = DevExpress.localization.formatMessage(info.text);
				}
			}
			var value = info.value;
			if (info.ident == "service")
			{
				if (info.value == "-1")
				{
					value = "STOPPED";
				}
				if (info.value == "0")
				{
					value = "NO LICENSE";
				}
				if (info.value == "1")
				{
					value = "TRIGGER";
				}
				if (info.value == "2")
				{
					value = "FREEFLOW";
				}
				if (info.value == "3")
				{
					value = "MOTION";
				}
				if (info.value == "4")
				{
					value = "LOADING";
				}
			}
			var lastchange = new Date(info.lastchange);
			//HH:mm:ss.SSS dd/MM/yyyy
			var formatTime = "";
			if (lastchange)
			{
				formatTime += ("0" + lastchange.getHours()).slice(-2);
				formatTime += ":";
				formatTime += ("0" + lastchange.getMinutes()).slice(-2);
				formatTime += ":";
				formatTime += ("0" + lastchange.getSeconds()).slice(-2);
				formatTime += ".";
				formatTime += ("00" + lastchange.getMilliseconds()).slice(-3);
				formatTime += " ";
				formatTime += ("0" + lastchange.getDate()).slice(-2);
				formatTime += "/";
				formatTime += ("0" + (lastchange.getMonth() + 1)).slice(-2);
				formatTime += "/";
				formatTime += lastchange.getFullYear();
				time = formatTime;
			}
			if ($("#StatusAttr" + elem + "Text").length != 0)
			{
				$("#StatusAttr" + elem + "Text").text(title);
			}
			if ($("#StatusAttr" + elem + "Value").length != 0)
			{
				$("#StatusAttr" + elem + "Value").text(value);
			}

			$("#StatusAttr" + elem + "Text").removeClass('Yellow');
			$("#StatusAttr" + elem + "Value").removeClass('Red');
			if ((info.ident == "SD" || info.ident == "CAMERA") && value <= 15 && value > 5)
			{
				$("#StatusAttr" + elem + "Text").addClass('Yellow');
				$("#StatusAttr" + elem + "Value").addClass('Yellow');
			}
			if ((info.ident == "SD" || info.ident == "CAMERA") && value <= 5)
			{
				$("#StatusAttr" + elem + "Text").addClass('Red');
				$("#StatusAttr" + elem + "Value").addClass('Red');
			}
			if (info.ident == "service" && value < 1)
			{
				$("#StatusAttr" + elem + "Text").addClass('Red');
				$("#StatusAttr" + elem + "Value").addClass('Red');
			}
			if (info.ident == "service" && value == 4)
			{
				$("#StatusAttr" + elem + "Text").addClass('Yellow');
				$("#StatusAttr" + elem + "Value").addClass('Yellow');
			}
			if (info.ident == "vicon_resolution")
			{
				if (info.value == "0")
				{
					value = "OK";
				}
				if (info.value == "1")
				{
					value = "NOT OK";
					$("#StatusAttr" + elem + "Text").addClass('Red');
					$("#StatusAttr" + elem + "Value").addClass('Red');
				}
			}
		});
		$("#StatusAttr4Time").text(time);
	}

	function loadStatus()
	{
		status = executeCGI(computerid, "status", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
	
		if (debugoptions)
		{
		}
		else
		{
			if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "AXIS" || DEFINE_INTERFACE == "HANWHA")
			{
				status = jQuery.grep(status, function(value)
				{
					return value.ident != "fps" && value.ident != "lasttime" && value.ident != "lastmotion" && value.ident != "queuesize" && value.ident != "framesdropped" && value.ident != "motion_noplates" && value.ident != "lastBRnumber" && value.ident != "lastBRtime";
				});
			}
			else if (DEFINE_INTERFACE == "VICON")
			{
				status = jQuery.grep(status, function(value)
				{
					return value.ident != "fps" && value.ident != "lasttime" && value.ident != "lastmotion" && value.ident != "queuesize" && value.ident != "framesdropped" && value.ident != "motion_noplates" && value.ident != "vicon_resolution" && value.ident != "lastBRnumber" && value.ident != "lastBRtime";
				});
			}
			else if (DEFINE_INTERFACE == "VIVOTEK_CV25")
			{
				status = jQuery.grep(status, function(value)
				{
					return value.ident != "fps" && value.ident != "lasttime" && value.ident != "lastmotion" && value.ident != "queuesize" && value.ident != "framesdropped" && value.ident != "motion_noplates" && value.ident != "lastBRnumber" && value.ident != "lastBRtime" && value.ident != "setInputTime" && value.ident != "classTime" && value.ident != "colorTime" && value.ident != "makeTime" && value.ident != "runTime" && value.ident != "totalTime";
				});
			}
		}

		if (DEFINE_INTERFACE == "ZKTECO")
		{
			loadStatusValues();
		}
	}

	function getResolution()
	{
		resolution = executeCGI(computerid, "select|table=nlconfcamera|maxvalues=100", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
		
		if(Array.isArray(resolution)){
			if(resolution.length>0){
				$.each(resolution, function(i, item)
				{
					if (item.id == 57)
					{
						if (item.name.includes("umresolution"))
						{
							var resopt = item.value.split("x");
							resx = resopt[0];
							resy = resopt[1];
						}
					}
					if (item.id == 5)
					{
						var resopt = item.value.split(";");
						roileft = resopt[0];
						roitop = resopt[1];
						roiwidth = resopt[2];
						roiheight = resopt[3];
					}
				});
			}
		}  
	}

	function getLanes()
	{
		lanes = executeCGI(computerid, "select|table=nlcameralane|maxvalues=2", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
	
		if(Array.isArray(lanes)){
			if(lanes.length>0){
				haveLanes = true;
				p0 = parseFloat(lanes[0].lpoint00X / 10000) * wdefined;
				p1 = parseFloat(lanes[0].lpoint01X / 10000) * wdefined;
			}
		}    
	}

	function getCrossLine()
	{
		crossLine = executeCGI(computerid, "select|table=nlcrossline|maxvalues=8", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
		
		numCrossline = crossLine.length;
		if (numCrossline > 0)
		{
			haveCrossline = true;
			for (var i=0; i<numCrossline; i++)
			{
				x0[i] = parseFloat(crossLine[i].lineX0) * wdefined;
				y0[i] = parseFloat(crossLine[i].lineY0) * hdefined;
				x1[i] = parseFloat(crossLine[i].lineX1) * wdefined;
				y1[i] = parseFloat(crossLine[i].lineY1) * hdefined;
				clarea1[i] = parseFloat(crossLine[i].roi1) * wdefined;
				clarea2[i] = parseFloat(crossLine[i].roi2) * hdefined;
				clarea3[i] = parseFloat(crossLine[i].roi3) * wdefined;
				clarea4[i] = parseFloat(crossLine[i].roi4) * hdefined;
			}
		}   
	}

	function getDateOverlay()
	{
		dateOverlay = executeCGI(computerid, "select|table=nlconfgeneral|maxvalues=100", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
		
		if(Array.isArray(dateOverlay)){
			if(dateOverlay.length>0){
				$.each(dateOverlay, function(i, item)
				{
					if (item.id == 55)
					{
						if (item.value == "true")
						{
							dateoverlay = true;
						}
						else
						{
							dateoverlay = false;
						}
					}
				});
			}
		}    
	}

	function refreshImage()
	{
		resfreshliveview();
		timer = setTimeout(refreshImage, timerefreshImagen);
	}

	function refreshInfo()
	{
		loadInfo(true);
		timer2 = setTimeout(refreshInfo, timerefreshInfo);
	}

	function refreshStatus()
	{
		timerstatus();
		timer3 = setTimeout(refreshStatus, timerrefreshStatus);
	}
	
	function resfreshliveview()
	{
		var d1 = new Date();
		var canvas = document.getElementById('canvas');
		var ctx = canvas.getContext('2d');
		var tmpImg = new Image();
		tmpImg.src = getSnapshotFromCamera(pathcgi, pathlive);
		tmpImg.onload = function()
		{
			try
			{
				ctx.drawImage(tmpImg, 0, 0, wdefined, hdefined);
				if (DEFINE_INTERFACE == "VICON")
				{
					getViconResolution();
					if (viconresolution)
					{
						ctx.fillStyle = 'white';
						ctx.fillRect(0, 0, wdefined, hdefined);
						
						ctx.font = "32px Arial";
						ctx.fillStyle = "#2B56A3";
						ctx.fillText(DevExpress.localization.formatMessage("Resolution is too high,"), 25, 175, wdefined);
						ctx.fillText(DevExpress.localization.formatMessage("please select a lower resolution"), 25, 225, wdefined);
					}
				}
				if (showroi && !viconresolution)
				{
					if (roiwidth != 0)
					{
						ctx.beginPath();
						var ppcX = parseFloat("0." + roileft);
						var ppcY = parseFloat("0." + roitop);
						var ppcwidth = parseFloat("0." + roiwidth);
						var ppcheight = parseFloat("0." + roiheight);
						ctx.rect(ppcX * wdefined, ppcY * hdefined, ppcwidth * wdefined, ppcheight * hdefined);
						ctx.strokeStyle = 'red';
						ctx.lineWidth = 5;
						ctx.stroke();
					}
					else if (roimessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No ROI to display"), "info", 1000);
						roimessagedisplayed = true;
					}
				}
				if (showlanes && !viconresolution)
				{
					if (haveLanes)
					{
						ctx.beginPath();
						ctx.strokeStyle = 'blue';
						ctx.lineWidth = 2;
						ctx.moveTo(p0, 0);
						ctx.lineTo(p1, hdefined);
						ctx.stroke();
					}
					else if (lanesmessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No lanes to display"), "info", 1000);
						lanesmessagedisplayed = true;
					}
				}
				if (showpattern && !viconresolution)
				{
					var linedraw = Math.round((25 * hdefined) / resy);
					ctx.beginPath();
					ctx.strokeStyle = 'white';
					ctx.lineWidth = 2;
					for (i = 0; i < hdefined; i += linedraw)
					{
						ctx.moveTo(0, i);
						ctx.lineTo(wdefined, i);
						ctx.stroke();
					}
				}
				if (showcrossline && !viconresolution)
				{
					if (haveCrossline)
					{
						for (var i=0; i<numCrossline; i++)
						{
							ctx.beginPath();
							ctx.strokeStyle = 'green';
							ctx.lineWidth = 2;
							ctx.moveTo(x0[i], y0[i]);
							ctx.lineTo(x1[i], y1[i]);
							ctx.stroke();
							
							ctx.beginPath();
							ctx.rect(clarea1[i], clarea2[i], clarea3[i], clarea4[i]);
							ctx.strokeStyle = 'green';
							ctx.lineWidth = 5;
							ctx.stroke();
						}
					}
					else if (crosslinemessagedisplayed == false)
					{
						DevExpress.ui.notify(DevExpress.localization.formatMessage("No Cross Line to display"), "info", 1000);
						crosslinemessagedisplayed = true;
					}
				}
				if ((dateoverlay) && ((!DEFINE_INTERFACE.includes("VIVOTEK")) || ((DEFINE_INTERFACE == "VIVOTEK"  || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA") && (timestamp_vivotek == "0"))))
				{
					var date = getStringNormalDateLive(d1);
					ctx.font = "14px Arial";
					ctx.strokeStyle = 'black';
					ctx.strokeText(date, 10, 20, wdefined);
					ctx.fillStyle = 'white';
					ctx.fillText(date, 10, 20, wdefined);
				}
			}
			catch (err)
			{}
		};
	}
	
	function getViconResolution()
	{
		$.ajax(
		{
			dataType: "json",
			url: pathcgi + "cgi-bin/vparcgi.cgi?computerid=" + computerid + "&oper=select&table=nlcounter&maxvalues=100&dd" + getStringNormalDate(new Date()) + localStorage.getItem("TOKEN"),
			async: false,
			success: function(data)
			{
				CheckTokenValidity(data);
				$.each(data, function(i, item)
				{
					if (item.ident == "vicon_resolution")
					{
						if (item.value == 1)
						{
							viconresolution = true;
						}
						else
						{
							viconresolution = false;
						}
					}
				});
			}
		});	
	}
	
	function settitleinfotitle(i, data, jj)
	{
		var j = 0;
		var lane = "";
		var iconimages = "";
		$("#title" + i).empty();
		$("#list" + i).empty();
		$("#make" + i).empty();
		$("#class" + i).empty();
		if (data[jj].laneid != 0)
		{
			if (data[jj].laneid % 2 == 0)
			{
				lane = "[" + DevExpress.localization.formatMessage("LANE 1") + "]";
			}
			else
			{
				lane = "[" + DevExpress.localization.formatMessage("LANE 2") + "]";
			}
		}
		if (data[jj].imagepath != "")
		{
			iconimages = "<img id='icimgt" + data[jj].id + "' src=images/images.png ><div id='tooltipt" + data[jj].id + "' style='display: none !important;'></div>"
		}

		var strDate = data[jj].timestamp.replace("T", " ");
		var itemDate = new Date(data[jj].timestamp.replace("T", " "));
		if(isNaN(itemDate))
		{
		    itemDate= new Date(data[jj].timestamp+'Z');
		}
		try{
			var formatedDate = liveDateFormat;
			formatedDate = formatedDate.replace("yyyy", itemDate.getFullYear());

			var month = itemDate.getMonth() +1;
			if(month < 10)
				month = "0"+month;
			formatedDate = formatedDate.replace("MM", month);

			var day = itemDate.getDate();
			if(day < 10)
				day = "0"+day;
			formatedDate = formatedDate.replace("dd", day);

			var milis = itemDate.getMilliseconds();
			if(milis < 10)
				milis = "0"+milis;
			formatedDate = formatedDate.replace("SSS", milis);

			var secs = itemDate.getSeconds();
			if(secs < 10)
				secs = "0"+secs;
			formatedDate = formatedDate.replace("ss", secs);

			var mins = itemDate.getMinutes();
			if(mins < 10)
				mins = "0"+mins;
			formatedDate = formatedDate.replace("mm", mins);

			var hours = itemDate.getHours();
			if(formatedDate.includes("hh")){
				hours = (itemDate.getHours() % 12) || 12;
				if(hours < 10)
					hours = "0"+hours;
				formatedDate = formatedDate.replace("hh",hours);
			}else if(formatedDate.includes("HH")){
				hours = itemDate.getHours();
				if(hours < 10)
					hours = "0"+hours;
				formatedDate = formatedDate.replace("HH", hours);
			}

			strDate = formatedDate;
		}catch(e){

		}

		$("#title" + i).append("<b>" + data[jj].numberplate + "</b> (" + dict[data[jj].country] + ") " + iconimages + "<br> " + lane + " " + data[jj].globalconfidence + "% " + data[jj].averagecharheight + "px <br>" + strDate + "<br>");
		
		if(DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA"){
			if(data[jj].make_str != null && data[jj].make_str != undefined && data[jj].veclass_str != undefined && data[jj].veclass_str != undefined && data[jj].color_str != undefined && data[jj].color_str != undefined){
				//data[jj].make_str = "testMaker";
				var classColor = data[jj].veclass_str.replace(/NLVEHICLE_CLASS_/g,'').toLowerCase() +"_"+ data[jj].color_str.toLowerCase();
				//var classColor = "VEHICLE_CLASS_MOTO".replace(/VEHICLE_CLASS_/g,'').toLowerCase() +"_"+ "PURPLE".toLowerCase();
				var tooltipText = classColor.split("_")[0]+" - "+classColor.split("_")[1];
					if(tooltipText == " - ")
						tooltipText="";
				$("#class"+ i).append("<img title='"+tooltipText+"' src="+getClassColorIcon(classColor, ClassVisible, ColorVisible)+" >"+"<label style='font-size: 9px;'>" + data[jj].make_str + "</label>");
			}
		}else{
			$("#class"+ i).remove();
		}

		var lists = "";
		if (data[jj].listid != "[-1]")
		{
			if (data[jj].listid.includes(";"))
			{
				var listas = data[jj].listid.split(";");
				$.each(listas, function(i, item)
				{
					lists += dictlist[item] + ";";
				});
				lists = lists.slice(0, -1);
			}
			else
			{
				lists = dictlist[data[jj].listid];
			}
			$("#list" + i).append(lists);
		}
		if (data[jj].imagepath != "")
		{
			CreateToolTipTop(data[jj].id, data[jj].evidences, data[jj].imagepath, data[jj].locatedPlate, data[jj].resultleft, data[jj].resulttop, data[jj].resultright, data[jj].resultbottom, data[jj].vehicleleft, data[jj].vehicletop, data[jj].vehicleright, data[jj].vehiclebottom, data[jj].width, data[jj].height, jj);
		}
	}

	function timerstatus()
	{
		if (showstatus)
		{
			loadStatus();
			if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "AXIS" || DEFINE_INTERFACE == "VICON" || DEFINE_INTERFACE == "HANWHA")
			{
				$('#gridstatus').dxDataGrid('instance').option("dataSource", status);
			}
		}
	}

	function loadSpeedGeneric(results)
	{
		//put a try/catch because the first time this timer fires the datagrid is not created, but the second and subsequent times there is no error and everything works as normal
		try
		{
			var dataItems = $('#gridContainer').dxDataGrid('instance').getDataSource().items();
			
			var dataItemsIDs =[];
			var resultItemsIDs =[];

			for(var i = 0; i < dataItems.length; i++){
				dataItemsIDs.push(Number(dataItems[i].id));
			}

			for(var j = 0; j < results.length; j++){
				resultItemsIDs.push(Number(results[j].id));
			}

			dataItemsIDs.sort();
			resultItemsIDs.sort();

			if(JSON.stringify(dataItemsIDs) != JSON.stringify(resultItemsIDs))
			{
				$('#gridContainer').dxDataGrid('instance').option("dataSource", results);
			}
		}
		catch (err)
		{}
	}

	function loadNotSpeedGeneric(data)
	{
		if (data.length > 0)
		{
			var dataGrid2 = $('#gridContainer2').dxDataGrid('instance');
			
			var diffItems = false; 
			var dataItemsIDs = lastSquareResults;
			var resultItemsIDs =[];

			for(var j = 0; j < data.length; j++){
				resultItemsIDs.push(Number(data[j].id));
			}

			dataItemsIDs.sort();
			resultItemsIDs.sort();

			if(JSON.stringify(dataItemsIDs) != JSON.stringify(resultItemsIDs))
				diffItems=true;

			lastSquareResults = resultItemsIDs;
			if(!diffItems)
				return;

			var last_index = ((index_peticion - 1) % 5);
			data.sort(function(a, b)
			{
				return b.id - a.id
			})
			$.each(data, function(indice, item)
			{
				if (indice < 5)
				{
					lastid = data[indice].id;
					var i = (index_peticion % 5);
					var j = 0;
					$('#imageretail' + i).hide();
					$('#image' + i).hide();
					if (data[indice].imagepath != "")
					{
						$('#image' + i).show();
						var canvas = document.getElementById('canvas' + i);
						var ctx = canvas.getContext('2d');
						var tmpImg = new Image();
						tmpImg.src = getImageFromCamera(pathcgi, computerid, data[indice].imagepath);
						tmpImg.onerror = function()
						{
							settitleinfotitle(i, data, indice);
							$('.boxOptions1').css('height', '282px');
						};
						tmpImg.onload = function()
						{
							settitleinfotitle(i, data, indice);
							$('.boxOptions1').css('height', '282px');
							// Store the current transformation matrix
							ctx.save();
							// Use the identity matrix while clearing the canvas
							ctx.setTransform(1, 0, 0, 1, 0, 0);
							ctx.clearRect(0, 0, 228, 192);
							// Restore the transform
							ctx.restore();
							ctx.beginPath();
							ctx.clearRect(0, 0, 228, 192);
							ctx.drawImage(tmpImg, 0, 0, 228, 192);
							ctx.rect(data[indice].resultleft * (widthdraw / data[indice].width), data[indice].resulttop * (heightdraw / data[indice].height), (data[indice].resultright - data[indice].resultleft) * (widthdraw / data[indice].width), (data[indice].resultbottom - data[indice].resulttop) * (heightdraw / data[indice].height));
							ctx.strokeStyle = 'green';
							ctx.lineWidth = 1;
							ctx.stroke();
						};
					}
					else if (data[indice].imageretailpath != "")
					{
						$('.boxOptions1').css('height', '150px');
						$('#imageretail' + i).show();
						$('#imgrtl' + i).attr('src', getImageFromCamera(pathcgi, computerid, data[indice].imageretailpath));
						settitleinfotitle(i, data, indice);
					}
					else
					{
						settitleinfotitle(i, data, indice);
						$('.boxOptions1').css('height', '95px');
					}
					index_peticion++;
				}
			});
			var index_actual = (index_peticion - 1) % 5;
			$("#mat" + last_index).addClass('demo-light');
			$("#mat" + index_actual).addClass('demo-light');
		}
	}

	function loadInfo(loadResults)
	{
		resData = executeCGI(computerid, "jsonlastresults", getStringNormalDate(new Date()), localStorage.getItem("TOKEN"), true);
		
		if(loadResults == false)
		{
			results = resData;
		}
		else
		{
			if (showreallive)
			{
				if (liveVelocidad == true)
				{
					loadSpeedGeneric(resData);
				}
				else
				{
					loadNotSpeedGeneric(resData);
				}
			}
		}
	}

	function configureZKReview()
	{
		$.getScript("index.js");
		//Añadimos el review por js
		var htmlReview1 = 
		"<div class='col_2' style='top: 75px; left: 800px;'>" +
			"<div class='dx-fieldset' style='margin: 0px 0px;'>" +
				"<div class='dx-field'>" +
					"<div class='dx-field-label' id='lbfromdate'>From date:</div>" +
					"<div class='dx-field-value'><div id='data1'></div></div>" +
				"</div>" +
				"<div class='dx-field'>" +
					"<div class='dx-field-label' id='lbtodate'>To date:</div>" +
					"<div class='dx-field-value'><div id='data2'></div></div>" +
				"</div>" +
				"<div class='dx-field' hidden>" +
					"<div class='dx-field-label'id= 'shnumreg' >Show num registers:</div>" +
					"<div class='dx-field-value'>" +
						"<div id='numreg'></div>" +
					"</div>" +
				"</div>" +
				"<div class='dx-field' style='padding: 2px 0px;'>" +
					"<div class='dx-field-label' style='display: flex; gap: 2px; width: 100%;'> ";

	var htmlReview2 =   "<div id='openBar' style='padding: 0px 3px;'></div>";
	
	var htmlReview3 =	"<div id='icon-done_info' style='padding: 0px 3px;'></div>" +
					"</div>" +
						"<div id='medium-indicator'></div>" +
					"</div>" +
				"</div>" +
			"</div>" +
			"<div class='col_2 no_margin_right' style='top: 75px; left: 1280px; float:right;'>" +
				"<div class='dx-fieldset' style='margin: 0px 0px;'>" +
					"<div class='dx-field'>" +
						"<div class='dx-field-label' id='lbplate'>Plate:</div>" +
						"<div class='dx-field-value'><div id='TxPlate'></div></div>" +
					"</div>" +
					"<div class='dx-field'>" +
						"<div class='dx-field-label' id='lblist'>List:</div>" +
						"<div class='dx-field-value'><div id='radio-group-simple'></div></div>" +
					"</div>" +
					"<div class='dx-field'>" +
						"<div class='dx-field-label' id='lblane'>Lane:</div>" +
						"<div class='dx-field-value'><div id='lane_list'></div></div>" +
					"</div>" +
			"</div>" +
		"</div>" +
				
		"<div class='content_wrapper' style='top: 320px; left: 830px; width: 100%; display: flex; flex-direction: column; align-items: flex-start;'>"+

			"<div class='demo-container' style='overflow-x: auto; width: 100%;'>"+
				"<div id='gridContainerReview'></div>"+
			"</div>"+

			"<div class='dx-field' style='padding: 2px 0px;'>"+
				"<div class='dx-field-label' style='display: flex; gap: 2px; width: 100%;'>"+
				"<div id='FirstPage' style='padding: 0px 3px;'></div>"+
				"<div id='PageAnt' style='padding: 0px 3px;'></div>"+
				"<div id='PageSig' style='padding: 0px 3px;'></div>"+
				"<div id='LastPage' style='padding: 0px 3px;'></div>"+
				"<div id='export' style='padding: 0px 3px;'></div>"+
				"</div>"+
			"</div>"+
		"</div>";

		if(DEFINE_PACKAGE == "ZKTECO")
		{
			var htmlReview = htmlReview1 + htmlReview2 + htmlReview3;
		}

		if(DEFINE_PACKAGE == "NEURAL")
		{
			var htmlReview = htmlReview1 + htmlReview3;
		}
		
		$("#field").append("<div><canvas id='canvas' style='top: 100px; left: 450px;' width='" + wdefined + "' height='" + hdefined + "'></canvas></div>");
		$("#field2").append(htmlReview);
		$("#gridContainer").remove();
		
		var htmllist = 
			"<div class='content_wrapper'>" +
				"<div class='demo-container'>" +
					"<div id='gridContainer' style='margin: auto; width: 100%; padding: 10px;'></div>" +
				"</div>" +
			"</div>";
		$("#field3").append(htmllist);
	}

	function getRTSPStream(rtspURL)
	{
		var address = "ws://"+location.host;
		var target = rtspURL;  // live.sdp, live2.sdp, live3.sdp
		
		var sid = "8523672543";
		
		ws = new WebSocket(address + '/ws/module_over_ws', 'vvtk-protocol');
		
		rtspChannel = new RTCRtspProtocol(ws);
		//console.log("Test rtspChannel" + JSON.stringify(rtspChannel));
		ws.onopen = function (ev) {
			ws.trigger('open', ev);

			// step 1. create a Liveview instance
			liveview = new Liveview({
				url: 'rtsp://localhost/' + target,
				rtspChannel: rtspChannel,
				volume: 0,
				mute: true,
				username: 'admin',
				sessionId: sid,
				width:wdefined,
				height:hdefined
			});

			// step 1.1 watch instance's event
			liveview.on('play', function () {
			//console.log('play', 'liveview\'s video is playing');
			});
			liveview.on('notify', function (notify) {
			// console.log('notify', notify.timestamp.stream);
			});

			// step 1.2 append the instance's video to the Document's body
			$("#field").find("video").remove();
			$("#field").prepend(liveview.video);
			$("video").css("width", wdefined+"px");
			$("video").css("height", hdefined+"px");
			liveview.play();
			//console.log("Play: " + JSON.stringify(liveview));
		};
	}

	function configureChecks(visorType, hdefined)
	{
		if(visorType == "getimage"){
			var checks = "<div id='shwRLIVE' style='float: left;margin-right: 10px;margin-top: 10px;' ></div>" +
				"<div id='shwESTATUS' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='float: left;margin-right: 10px;margin-top: 10px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='float: left;margin-right: 5px;margin-top: 10px;margin-left: 0px;' ></div>";
		}else{
			var checks = "<div style='margin-top: -390px;'><div id='shwRLIVE' style='margin-right: 10px;margin-top: -" + hdefined + "px;' ></div>" +
				"<div id='shwESTATUS' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwROI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwLNS' style='margin-right: 10px;margin-top: -" + hdefined + "px;margin-left: 10px;' ></div>" +
				"<div id='shwGUI' style='margin-right: 5px;margin-top: -" + hdefined + "px;margin-left: 0px;' ></div></div>";
		}

		return checks;
	}

	function configureRealViewForHanwha(hdefined)
	{
		var serverName	= window.location.hostname;
		var serverType = "http://";
		var extention = "/livemjpeg";
		var liveStreamURI = serverType + serverName + ":1234" + extention;
		if(ie)
		$("#field").append("<label id='liveError' style='position: absolute; margin: "+((wdefined/2)-150)+"px "+hdefined/2+"px; font-size: 30px; z-index: -1;'>Cannot load viewer</label>");
		$("#field").append("<img id='streaming_uri' style='margin:auto;' width='" + wdefined + "' height='" + hdefined + "' src='"+liveStreamURI+"'>");
		$("#field").append("<canvas id='canvas' style='margin:auto; position:relative; top : -"+(hdefined+5)+"px;' width='"+wdefined+"' height='"+hdefined+"'></canvas>");
	}

	function configureRealView()
	{
		if (visorType == "realtime")
		{
			var ua = window.navigator.userAgent;
			var msie = ua.indexOf("MSIE ");
			if (msie > 0 || !!navigator.userAgent.match(/Trident.*rv\:11\./))  // If Internet Explorer, return version number
			{
			}
			$.ajax({
		
				url: pathcgi + "../cgi-bin/viewer/getparam.cgi?network_rtsp_s0_accessname",
				async: false,
				success: function (data) {
					rtspURL= data.split("=")[1].split("'")[1];
				}
			});

			$.ajax({	
				url: pathcgi + "../cgi-bin/viewer/getparam.cgi?network_rtsp_port",
				async: false,
				success: function (data) {
					rtspport= data.split("=")[1].split("'")[1];
				}
			});

			if(!ie)
			{
				getRTSPStream(rtspURL);
				$("#field").append("<canvas id='canvas' style='margin:auto; position:relative; top : -"+(hdefined+5)+"px;' width='"+wdefined+"' height='"+hdefined+"'></canvas>");
			}
		}
		
		if (DEFINE_INTERFACE == "ZKTECO")
		{
			configureZKReview();
		}
		else
		{
			if(visorType == "getimage")
			{
				$("#field").append("<canvas id='canvas' style='margin:auto;' width='" + wdefined + "' height='" + hdefined + "'></canvas>");
			}

			$("#field2").append("<div id = 'gridstatus' style='float:right;max-width: 450px;'></div>");
			$("#StatusAttr").remove();
		}

		if((DEFINE_INTERFACE == "HANWHA") && (visorType == "mjpeg"))
		{
			configureRealViewForHanwha(hdefined);
		}

		var checks = configureChecks(visorType, hdefined);

		$("#field").append(checks);
	}

	function getTimeStampVivotek()
	{
		if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "VIVOTEK_CV25")
		{
			// GET TIMESTAMP VIVOTEK
			$.ajax(
			{
				url: pathcgi + "../cgi-bin/admin/getparam.cgi?videoin_imprinttimestamp",
				async: false,
				success: function (data)
				{
					if (data.split("=").length > 1)
					timestamp_vivotek = data.split("=")[1].split("'")[1];
				}
			});
		}else if(DEFINE_INTERFACE == "HANWHA")
		{

		}
	}

	function detectIE()
	{
		var ua = window.navigator.userAgent;
		var msie = ua.indexOf('MSIE ');
		if (msie > 0)
		{
			// IE 10 or older => return version number
			return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
		}
		var trident = ua.indexOf('Trident/');
		if (trident > 0)
		{
			// IE 11 => return version number
			var rv = ua.indexOf('rv:');
			return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
		}
		var edge = ua.indexOf('Edge/');
		if (edge > 0)
		{
			// Edge (IE 12+) => return version number
			return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
		}
		// other browser
		return false;
	}

	function createStatusGrid()
	{
		$("#gridstatus").dxDataGrid(
		{
			dataSource: status,
			showColumnHeaders: true,
			showBorders: true,
			showRowLines: true,
			keyExpr: "ident",
			hoverStateEnabled: true,
			paging:
			{
				pageSize: 18
			},
			columns: [
			{
				dataField: "text",
				caption: DevExpress.localization.formatMessage("Attribute"),
				width: 170,
				cellTemplate: function(element, info)
				{
					if (info.row.data.ident == "service")
					{
						var ee = info.text.split(";")
						if (ee.length > 1)
						{
							element.append(DevExpress.localization.formatMessage(ee[0]) + ee[1]);
						}
						else
						{
							element.append(DevExpress.localization.formatMessage(info.text));
						}
					}
					else
					{
						element.append(DevExpress.localization.formatMessage(info.text))
					}
				}
			},
			{
				width: 100,
				dataField: "value",
				caption: DevExpress.localization.formatMessage("Value"),
				cellTemplate: function(element, info)
				{
					if (info.row.data.ident != "service")
					{
						element.append(info.text)
						////////////////////////////////////////
						if(info.data.visible == 0){
							element[0].style.display="none";
						}else if(info.data.visible == 1){
							element[0].style.display="block";
						}else if(info.data.visible == 2){
							if(debugoptions)
							element[0].style.display="block";
							else
							element[0].style.display="none";
						}
						////////////////////////////////////////
					}
					else
					{
						if (info.text == "-1")
						{
							element.append("STOPPED")
						}
						if (info.text == "0")
						{
							element.append("NO LICENSE")
						}
						if (info.text == "1")
						{
							element.append("TRIGGER")
						}
						if (info.text == "2")
						{
							element.append("FREEFLOW")
						}
						if (info.text == "3")
						{
							element.append("MOTION")
						}
						if (info.text == "4")
						{
							element.append("LOADING")
						}
					}
				}
			},
			{
				dataField: "lastchange",
				dataType: "date",
				caption: DevExpress.localization.formatMessage("Last Change"),
				width: 180,
				format: liveDateFormat
			}],
			onRowPrepared: function(row)
			{

				////////////////////////////////////////
					var rowInfo = status[row.rowIndex];
					if(rowInfo != undefined){
						//console.log("Info: " + JSON.stringify(rowInfo));
						if(rowInfo.visible == 0){
							row.rowElement[0].style.display = "none";
						}else if(rowInfo.visible == 1){
							row.rowElement[0].style.display = "table-row";
						}else if(rowInfo.visible == 2){
							if(debugoptions==1){
							row.rowElement[0].style.display = "table-row";
							}else{
								row.rowElement[0].style.display = "none";
						}
						}
					}
					////////////////////////////////////////
				if (row.rowType == "data")
				{
					row.rowElement[0].style.whiteSpace = "break-spaces";
					//console.log("TEST ASTERISCO: Traduccion '"+ DevExpress.localization.formatMessage(row.data.text) + "' vs original '" + row.data.text+"'");
					//row.rowElement[0].title = DevExpress.localization.formatMessage(row.data.text) != row.data.text ? DevExpress.localization.formatMessage(row.data.text) : row.data.text+"*";
					row.rowElement[0].title = DevExpress.localization.formatMessage(row.data.text);
					
					if ((row.data.ident == "SD" || row.data.ident == "CAMERA") && row.data.value <= 15 && row.data.value > 5)
					{
						row.rowElement.addClass('Yellow');
					}
					if ((row.data.ident == "SD" || row.data.ident == "CAMERA") && row.data.value <= 5)
					{
						row.rowElement.addClass('Red');
					}
					if (row.data.ident == "service" && row.data.value < 1)
					{
						row.rowElement.addClass('Red');
					}
					if (row.data.ident == "service" && row.data.value == 4)
					{
						row.rowElement.addClass('Yellow');
					}
				}
			}
		});
	}

	function createInfoZKTEKO()
	{
		$("#gridContainer").dxDataGrid(
		{
			dataSource: results,
			showBorders: true,
			showRowLines: true,
			keyExpr: "id",
			height: 270,
			hoverStateEnabled: true,
			columns: [
				{
					dataField: "id",
					caption: "ID",
					width: ID_WIDTH * factorOfWidthFields,
					alignment: 'center',
					sortIndex: 0,
					sortOrder: "desc",
					allowSorting: false
				},
				{
					dataField: "timestamp",
					dataType: "date",
					caption: DevExpress.localization.formatMessage("Time"),
					width: DATE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					format: liveDateFormat,
					allowSorting: false
				},
				{
					dataField: "numberplate",
					width: PLATE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					caption: DevExpress.localization.formatMessage("Plate"),
					allowSorting: false
				},
				{
					dataField: "laneid",
					width: LANE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					caption: DevExpress.localization.formatMessage("Lane"),
					visible:LaneVisible,
					allowSorting: false,
					cellTemplate: function(element, info)
					{
						if (info.text == 0)
						{
							element.append("");
						}
						else
						{
							if (info.text % 2 == 0)
							{
								element.append(DevExpress.localization.formatMessage("LANE 1"));
							}
							else
							{
								element.append(DevExpress.localization.formatMessage("LANE 2"));
							}
						}
					}
				},
				{
					dataField: "direction",
					width: DIRECTION_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: DirectionVisible, 
					caption: DevExpress.localization.formatMessage("Direction"),
					allowSorting: false,
					cellTemplate: function(element, info)
					{
						if (info.text == 0)
						{
							element.append(DevExpress.localization.formatMessage("No Direction"));
						}
						else if (info.text == 1)
						{
							element.append(DevExpress.localization.formatMessage("Coming"));
						}
						else if (info.text == -1)
						{
							element.append(DevExpress.localization.formatMessage("Going"));
						}
					}
				},
				{
					dataField: "globalconfidence",
					width: CONF_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: ConfVisible, 
					allowSorting: false,
					caption: DevExpress.localization.formatMessage("Conf.")
				},
				{
					dataField: "averagecharheight",
					width: HEIGHT_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: HeightVisible,
					allowSorting: false,
					caption: DevExpress.localization.formatMessage("Heigth")
				},
				{
					dataField: "country",
					width: COUNTRY_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: CountryVisible,
					caption: DevExpress.localization.formatMessage("CountryState"),
					allowSorting: false,
					cellTemplate: function(element, info)
					{
						element.append(dict[info.text]);
					}
				},
				{
					dataField: "namelistid",
					width: LIST_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: ListVisible,
					caption: DevExpress.localization.formatMessage("List"),
					allowSorting: false,
					cellTemplate: function(element, info)
					{
						if (info.text != "not in list")
						{
							element.append(info.text);
						}
						else
						{
							element.append("");
						}
					}
				},{
					dataField: "imageretailpath",
					caption: DevExpress.localization.formatMessage("Image"),
					width: IMAGE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					allowSorting: false,
					cellTemplate: function(element, info)
					{
						if (info.text != "")
						{
							
							element.append("<img id='icimg" + info.key + "' src='" + getImageFromCamera(pathcgi, computerid, info.text ) + "' height = '20' width='125'><div id='tooltip" + info.key + "'></div>")
							if (info.row.data.imagepath != "")
							{
								CreateToolTip(info.key, info.row.data.evidences, info.row.data.imagepath, info.row.data.locatedPlate, info.row.data.resultleft, info.row.data.resulttop, info.row.data.resultright, info.row.data.resultbottom, info.row.data.vehicleleft, info.row.data.vehicletop, info.row.data.vehicleright, info.row.data.vehiclebottom, info.row.data.width, info.row.data.height);
							}
						}
						else
						{
							element.append(DevExpress.localization.formatMessage("No image"));
						}
					}
				}
			],
			onRowPrepared: function(row)
			{
				if (row.rowType == "data")
				{
					if(ListVisible){
						if(row.data.listid != "[-1]")
								row.rowElement.addClass('Red');
					}
				}
			}
		});
	}

	function createInfoGeneric()
	{
		$("#gridContainer").dxDataGrid(
		{
			dataSource: results,
			showBorders: true,
			showRowLines: true,
			keyExpr: "id",
			height: 270,
			hoverStateEnabled: true,
			columns: [
				{
					dataField: "id",
					caption: "ID",
					width: ID_WIDTH * factorOfWidthFields,
					alignment: 'center',
					sortIndex: 0,
					sortOrder: "desc"
				},
				{
					dataField: "timestamp",
					dataType: "date",
					caption: DevExpress.localization.formatMessage("Time"),
					width: DATE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					format: liveDateFormat
				},
				{
					dataField: "numberplate",
					width: PLATE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					caption: DevExpress.localization.formatMessage("Plate")
				},
				{
					dataField: "laneid",
					width: LANE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					caption: DevExpress.localization.formatMessage("Lane"),
					visible:LaneVisible,
					cellTemplate: function(element, info)
					{
						if (info.text == 0)
						{
							element.append("");
						}
						else
						{
							if (info.text % 2 == 0)
							{
								element.append(DevExpress.localization.formatMessage("LANE 1"));
							}
							else
							{
								element.append(DevExpress.localization.formatMessage("LANE 2"));
							}
						}
					}
				},
				//Faltan DirectionVisible - SpeedVisible - 
				{
					dataField: "direction",
					width: DIRECTION_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: DirectionVisible, 
					caption: DevExpress.localization.formatMessage("Direction"),
					cellTemplate: function(element, info)
					{
						if (info.text == 0)
						{
							element.append(DevExpress.localization.formatMessage("No Direction"));
						}
						else if (info.text == 1)
						{
							element.append(DevExpress.localization.formatMessage("Coming"));
						}
						else if (info.text == -1)
						{
							element.append(DevExpress.localization.formatMessage("Going"));
						}
					}
				},
				{
					dataField: "speed",
					width: SPEED_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: SpeedVisible, 
					caption: DevExpress.localization.formatMessage("Speed")
				},
				{
					dataField: "globalconfidence",
					width: CONF_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: ConfVisible, 
					caption: DevExpress.localization.formatMessage("Conf.")
				},
				{
					dataField: "averagecharheight",
					width: HEIGHT_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: HeightVisible,
					caption: DevExpress.localization.formatMessage("Heigth")
				},
				{
					dataField: "processtime",
					width: TIME_WIDTH * factorOfWidthFields,
					alignment: 'center',
					caption: DevExpress.localization.formatMessage("Time"),
					visible: debugoptions
				},
				{
					dataField: "country",
					width: COUNTRY_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: CountryVisible,
					caption: DevExpress.localization.formatMessage("CountryState"),
					cellTemplate: function(element, info)
					{
						element.append(dict[info.text]);
					}
				},
				{
					dataField: "namelistid",
					width: LIST_WIDTH * factorOfWidthFields,
					alignment: 'center',
					visible: ListVisible,
					caption: DevExpress.localization.formatMessage("List"),
					cellTemplate: function(element, info)
					{
						if (info.text != "not in list")
						{
							element.append(info.text);
						}
						else
						{
							element.append("");
						}
					}
				},
				{
					dataField: "veclass_str",
					width: CLASS_WIDTH * factorOfWidthFields,
					alignment: 'center',
					caption: function() {
			
						return getClassColorColumnName(ClassVisible, ColorVisible);
					},
					calculateCellValue: function(rowData) {
						return rowData.veclass_str.replace(/NLVEHICLE_CLASS_/g,'').toLowerCase() +"_"+ rowData.color_str.toLowerCase();
						//return "2" +"#"+ "RED";
					},
					cellTemplate: function(element, info)
					{	
						element.css({textAlign: "center"});
						//element.append(info.text.split("#")[0]);
						element.append("<img src='" + getClassColorIcon(info.text, ClassVisible, ColorVisible)  + "' height = '20' width='20'>");
					},
					visible: (ClassVisible || ColorVisible)
				},
				{
					dataField: "make_str",
					width: MAKE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					caption: DevExpress.localization.formatMessage("Make"),
					visible: MakeVisible
				},
				{
					dataField: "imageretailpath",
					caption: DevExpress.localization.formatMessage("Image"),
					width: IMAGE_WIDTH * factorOfWidthFields,
					alignment: 'center',
					cellTemplate: function(element, info)
					{
						if (info.text != "")
						{
							element.append("<img id='icimg" + info.key + "' src='" + getImageFromCamera(pathcgi, computerid, info.text ) + "' height = '20' width='125'><div id='tooltip" + info.key + "'></div>")
							if (info.row.data.imagepath != "")
							{
								CreateToolTip(info.key, info.row.data.evidences, info.row.data.imagepath, info.row.data.locatedPlate, info.row.data.resultleft, info.row.data.resulttop, info.row.data.resultright, info.row.data.resultbottom, info.row.data.vehicleleft, info.row.data.vehicletop, info.row.data.vehicleright, info.row.data.vehiclebottom, info.row.data.width, info.row.data.height);
							}							
						}
						else
						{
							element.append(DevExpress.localization.formatMessage("No image"));
						}
					}
				}
			],
			onRowPrepared: function(row)
			{
				if (row.rowType == "data")
				{
					if(ListVisible){
						if(row.data.listid != "[-1]")
								row.rowElement.addClass('Red');
					}
				}
			}
		});
	}

	function createInfoGrid()
	{
		if (liveVelocidad)
		{
			$("#bxopt1").hide();
			if (DEFINE_INTERFACE == "ZKTECO")
			{
				createInfoZKTEKO();
			}
			else
			{
				createInfoGeneric();
			}
		}
	}

	function createROICheckBox()
	{
		$("#shwROI").dxCheckBox(
		{
			value: false,
			text: DevExpress.localization.formatMessage("Show Roi"),
			onValueChanged: function(data)
			{
				showroi = data.value;
				if (data.value == false)
				{
					roimessagedisplayed = false;
				}
	
				if (visorType != "getimage") {
					var canvas = document.getElementById('canvas');
					var ctx = canvas.getContext('2d');
	
					if (showroi && !viconresolution)
					{
						if (roiwidth != 0)
						{
							reDrawCanvas();
						}
						else if (roimessagedisplayed == false)
						{
							DevExpress.ui.notify(DevExpress.localization.formatMessage("No ROI to display"), "info", 1000);
							roimessagedisplayed = true;
						}
					}else{
						ctx.clearRect(0, 0, wdefined, hdefined);
						reDrawCanvas();
					}
				}
			}
		});
	}

	function createShowLanesCheckBox()
	{
		$("#shwLNS").dxCheckBox(
		{
			value: false,
			text: DevExpress.localization.formatMessage("Show lanes"),
			onValueChanged: function(data)
			{
				showlanes = data.value;
				if (data.value == false)
				{
					lanesmessagedisplayed = false;
				}
	
				if (visorType != "getimage"){
					var canvas = document.getElementById('canvas');
					var ctx = canvas.getContext('2d');
	
					if (showlanes && !viconresolution)
					{
						if (haveLanes)
						{
							reDrawCanvas();
						}
						else if (lanesmessagedisplayed == false)
						{
							DevExpress.ui.notify(DevExpress.localization.formatMessage("No lanes to display"), "info", 1000);
							lanesmessagedisplayed = true;
						}
					}else{
						ctx.clearRect(0, 0, wdefined, hdefined);
						reDrawCanvas();
					}
				}
			}
		});
	}

	function createCalibrationPatternCheckBox()
	{
		$("#shwGUI").dxCheckBox(
		{
			value: false,
			text: DevExpress.localization.formatMessage("Calibration pattern"),
			onValueChanged: function(data)
			{
				showpattern = data.value;
				if (visorType != "getimage") {
					var canvas = document.getElementById('canvas');
					var ctx = canvas.getContext('2d');
	
					if (showpattern && !viconresolution)
					{
						reDrawCanvas();
					}else{
						ctx.clearRect(0, 0, wdefined, hdefined);
						reDrawCanvas();
					}
				}
			}
		});
	}

	function createShowRealLiveCheckBox()
	{
		$("#shwRLIVE").dxCheckBox(
		{
			value: true,
			text: DevExpress.localization.formatMessage("Show Real Live"),
			onValueChanged: function(data)
			{
				showreallive = data.value;
				if (data.value)
				{
					$("#gridContainer > .dx-datagrid").css("background-color", "white");
					$("#mat0").removeClass('gris');
					$("#mat1").removeClass('gris');
					$("#mat2").removeClass('gris');
					$("#mat3").removeClass('gris');
					$("#mat4").removeClass('gris');
					$("#mat0").addClass('demo-dark');
					$("#mat1").addClass('demo-dark');
					$("#mat2").addClass('demo-dark');
					$("#mat3").addClass('demo-dark');
					$("#mat4").addClass('demo-dark');
				}
				else
				{
					$("#gridContainer > .dx-datagrid").css("background-color", "#c6c8ca");
					$("#mat0").removeClass('demo-light');
					$("#mat0").removeClass('demo-dark');
					$("#mat1").removeClass('demo-light');
					$("#mat1").removeClass('demo-dark');
					$("#mat2").removeClass('demo-light');
					$("#mat2").removeClass('demo-dark');
					$("#mat3").removeClass('demo-light');
					$("#mat3").removeClass('demo-dark');
					$("#mat4").removeClass('demo-light');
					$("#mat4").removeClass('demo-dark');
					$("#mat0").addClass('gris');
					$("#mat1").addClass('gris');
					$("#mat2").addClass('gris');
					$("#mat3").addClass('gris');
					$("#mat4").addClass('gris');
				}
			}
		});
	}

	function createStatusCheckBox()
	{
		$("#shwESTATUS").dxCheckBox(
		{
			value: true,
			text: DevExpress.localization.formatMessage("Show status"),
			onValueChanged: function(data)
			{
				showstatus = data.value;
				if (DEFINE_INTERFACE == "ZKTECO")
				{
					$("#StatusAttrTable").css("background-color", showstatus ? "white" : "#c6c8ca");
				}
				else
				{
					if (data.value)
					{
						$("#gridstatus > .dx-datagrid").css("background-color", "white");
					}
					else
					{
						$("#gridstatus > .dx-datagrid").css("background-color", "#c6c8ca");
					}
				}
			}
		});
	}

	function createShowCrossLineCheckBox()
	{
		$("#shwCROSS").dxCheckBox(
		{
			value: false,
			text: DevExpress.localization.formatMessage("Show Cross Line"),
			onValueChanged: function(data)
			{
				showcrossline = data.value;
				if (data.value == false)
				{
					crosslinemessagedisplayed = false;
				}
	
				if (visorType != "getimage") {
					var canvas = document.getElementById('canvas');
					var ctx = canvas.getContext('2d');
	
					if (showcrossline && !viconresolution)
					{
						if (haveCrossline)
						{
							reDrawCanvas();
						}
						else if (roimessagedisplayed == false)
						{
							DevExpress.ui.notify(DevExpress.localization.formatMessage("No Cross Line to display"), "info", 1000);
							crosslinemessagedisplayed = true;
						}
					}else{
						ctx.clearRect(0, 0, wdefined, hdefined);
						reDrawCanvas();
					}
				}
			}
		});
	}

	function createCheckBoxes()
	{
		createROICheckBox();

		createShowLanesCheckBox();

		createCalibrationPatternCheckBox();

		createShowRealLiveCheckBox();

		createStatusCheckBox();

		createShowCrossLineCheckBox();
	}	

	String.prototype.includes = function(str)
	{
		var returnValue = false;
		if (this.indexOf(str) !== -1)
		{
			returnValue = true;
		}
		return returnValue;
	};

	$.urlParam = function(name)
	{
		var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
		if (results == null)
		{
			return null;
		}
		else
		{
			return results[1] || 0;
		}
	}

	$(".boxOptions1").dxBox(
	{
		direction: "row",
		width: "100%",
		height: 270
	});

	var timer;
	var timer2;
	var timer3;
	var i = 0;
	var d1 = new Date();
	var d2 = new Date();
	var lastid = -1;
	var lastSquareResults = [];
	var images = [];
	var resx = 0;
	var resy = 0;
	var roitop = 0;
	var roileft = 0;
	var roiwidth = 0;
	var roiheight = 0;
	var widthdraw = 229;
	var heightdraw = 192;
	var index_peticion = 0;
	var wdefined = 691;
	var hdefined = 389;

	if (DEFINE_INTERFACE == "ZKTECO")
	{
		wdefined = 750; 
		hdefined = 430; 
	}

	var showroi = false;
	var roimessagedisplayed = false;
	var showlanes = false;
	var lanesmessagedisplayed = false;
	var showpattern = false;
	var showreallive = true;
	var showstatus = true;
	var showcrossline = false;
	var crosslinemessagedisplayed = false;
	var dateoverlay = false;

	if (DEFINE_INTERFACE == "VIVOTEK" || DEFINE_INTERFACE == "VIVOTEK_CV25" || DEFINE_INTERFACE == "HANWHA")
	{
		var timestamp_vivotek = "0";
	}

	var viconresolution = false;
	var results = [];
	//lane variables
	var haveLanes = false;
	var p0 = 0;
	var p1 = 0;
	var ie = detectIE();
	var rtspURL = "";
	var rtspport = "554";
	var ws, rtspChannel;
	var liveview;
	//crossline variables
	var numCrossline = 0;
	var haveCrossline = false;
	var x0 = [0,0];
	var y0 = [0,0];
	var x1 = [0,0];
	var y1 = [0,0];
	var clarea1 = [0,0];
	var clarea2 = [0,0];
	var clarea3 = [0,0];
	var clarea4 = [0,0];

	var timerefreshImagen = 1000;
	var timerefreshInfo = 3000;
	var timerrefreshStatus = 1000;
	var timerautrorefresh = 1000 * 60 * 60;
	var debugoptions = false;
	var aplication;

	//Visibility Options
	var LaneVisible = false;
	var DirectionVisible = false;
	var SpeedVisible = false;
	var ConfVisible = false;
	var HeightVisible = false;
	var CountryVisible = false;
	var ListVisible = false;
	var ClassVisible = false;
	var ColorVisible = false;
	var MakeVisible = false;
	var factorOfWidthFields;

	if (DEFINE_INTERFACE == "ZKTECO")
	{
		var ID_WIDTH = 80;
		var DATE_WIDTH = 180;
		var PLATE_WIDTH = 120;
		var LANE_WIDTH = 120;
		var DIRECTION_WIDTH = 120;
		var CONF_WIDTH = 100;
		var HEIGHT_WIDTH = 120;
		var COUNTRY_WIDTH = 140;
		var LIST_WIDTH = 160;
		var IMAGE_WIDTH = 140;
	}
	else
	{
		var ID_WIDTH = 80;
		var DATE_WIDTH = 180;
		var PLATE_WIDTH = 100;
		var LANE_WIDTH = 80;
		var DIRECTION_WIDTH = 100;
		var CONF_WIDTH = 100;
		var HEIGHT_WIDTH = 80;
		var COUNTRY_WIDTH = 115;
		var LIST_WIDTH = 100;
		var IMAGE_WIDTH = 140;
		var CLASS_WIDTH = 100;
		var SPEED_WIDTH = 100;
		var TIME_WIDTH = 90;
		var MAKE_WIDTH = 90;
	}
				
	var visorType ="realtime";
	var testFirstClick = true;

	var dict = {};
	var dictlist = {};
	var status = [];

	Init_translate();

	make_header("index");

	set_rcpopup();

	set_uppopup();
	
	callGetGeneralConfiguration();

	if (visorType == "realtime")
	{
		document.body.addEventListener("click", clickBody);
	}

	configureWebIcon();

	setTimeout(function()
	{
		location.reload(true);
	}, timerautrorefresh);
		
	if ($.urlParam('debugoptions') != null && $.urlParam('debugoptions') == 1)
	{
		debugoptions = true;
	}

	configureRealView();

	callToGetTimeCamera();

	getConfigurations(dict, dictlist);

	getResolution();

	getLanes();

	getCrossLine();

	getDateOverlay();

	if (DEFINE_INTERFACE == "VICON")
	{
		getViconResolution();
	}

	getTimeStampVivotek();

	createCheckBoxes();

	createStatusGrid();

	createInfoGrid();

	loadStatus();

	loadInfo(false);

	if (visorType == "getimage")
	{
		refreshImage();
	}

	refreshStatus();

	refreshInfo();
});
